<?php
abstract class AbstractBasket {
    protected $obsah = array();
    public function add ($zbozi) {
        $this->obsah[] = $zbozi;
    }
    
    public function remove ($zbozi) {
        foreach ($this->obsah as $klic => $polozka) {
            if ($polozka == $zbozi) unset($this->zboz[$klic]);
        }
    }
    
    public abstract function load();
    public abstract function save();

}



class FileBasket extends AbstractBasket {

  public function load(){
    $file = fopen("kosik.txt","r");
    $this->obsah = array();
    while ($radek = fgets($file)) {
      $this->obsah[] = $radek;
    }  
    fclose($file);
  }
  
  public function save() {
    $file = fopen("kosik.txt","w");
    foreach ($this->obsah as $polozka) {
      fputs($file, $polozka."\r\n");
    }
    fclose($file);
  }
}

//$kosik = new AbstractBasket(); // nejde
$kosik = new FileBasket();
$kosik->add("Brambory");
$kosik->add("Jablka");
$kosik->save();

$kosik2 = new FileBasket();
$kosik2->load();

var_dump($kosik2);
?>
