<?php
// mejme tridu A
class A {
	private $text = null;
	
	// text je typu string, nemuzeme pouzit hinting, je to jednoduchy dat. typ
	public function __construct($text) {
		$this->text = $text;
	}
	
	public function getText(){
		return $this->text;
	}
}

// mejme tridu C, nema s A nic spolecneho
class C {
	
	
}

// mejme jinou tridu
class B {
	private $messages = array();	
	public function __construct() {
	}
	
	// zde je typova kontrola, neni mozne volat jinak nez s instanci 
	// tridy A jako param
	public function addMessage(A $message) {
		$this->messages[] = $message;
		echo "zavolana varianta A";
	}	
	
	
	// pretezovani jako v Jave nefunguje!!! fatal error
	public function addMessage(C $message) {
		echo "zavolana varianta C";
	}
	
	public function getMessages ($delimiter) {
		return $this->messages;
	}	
}


$b = new B();
//$b->addMessage("vzkaz");  // toto je chyba, neprojde pres type hinting
$b->addMessage(new A("vkaz")); // toto je OK, kontrola typu v poho


?>