<?php

define ("DB_HOST", "localhost");
define ("DB_NAME", "x36www");
define ("DB_USER", "x36www_user");
define ("DB_PASSWD", "x36heslo");


// jedina trida, ktera umi vsechno s DB
class DB {
	private static $instance = null;
	private $db_link = null;
	private $result = null;

	private function __construct() {
	}

	public static function getInstance() {
		if (self::$instance == null) {
			self::$instance = new DB();
			self::$instance->connect();
		}
		return self::$instance;
	}

	public function connect() {
		if ($this->db_link == null) {
			$link = mysqli_connect(DB_HOST, DB_USER, DB_PASSWD, DB_NAME);
			if (!$link) {
				throw new DBException(mysqli_errno($link));
			}
			mysqli_select_db($link,DB_NAME);
			$this->db_link = $link;
		}
		return $this->db_link;
	}

	public function query($sql) {
		$this->connect();
		$this->result = mysqli_query($this->db_link,$sql);
		if (mysqli)
		if (!$this->result) {
			throw new DBException(mysqli_error($this->db_link), $sql);
		}
		return $this->result;
	}
}

//________________________________________________________

class DBException extends Exception {
	public $error_str;
	public $query_str;
	public function __construct($error_str, $query_str=null) {
		parent::__construct($error_str);
		$this->query_str = $query_str;
	}
}


//_________________________________________________________


// voladni staticke metody, ta vrati instanci
$db = DB::getInstance();

// nad instanci uz volame jeji instancni metody
$result = $db->query("SELECT * FROM zbozi");


// za 1000 radku potrebuje opet instance pro pripojeni k DB
$db2 = DB::getInstance(); // $db  a $db2 ukazuji na stejnou instanci
// vesele pouzivame $db2
$result = $db->query("SELECT * FROM zbozi LIMIT 10");

?>